Index: trunk/src/VBox/Devices/Network/slirp/bootp.h
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/bootp.h	(revision 15092)
+++ trunk/src/VBox/Devices/Network/slirp/bootp.h	(revision 15093)
@@ -1,95 +1,95 @@
 /* bootp/dhcp defines */
 
-#define BOOTP_SERVER	67
-#define BOOTP_CLIENT	68
+#define BOOTP_SERVER    67
+#define BOOTP_CLIENT    68
 
-#define BOOTP_REQUEST	1
-#define BOOTP_REPLY	2
+#define BOOTP_REQUEST   1
+#define BOOTP_REPLY     2
 
-#define RFC1533_COOKIE		99, 130, 83, 99
-#define RFC1533_PAD		0
-#define RFC1533_NETMASK		1
-#define RFC1533_TIMEOFFSET	2
-#define RFC1533_GATEWAY		3
-#define RFC1533_TIMESERVER	4
-#define RFC1533_IEN116NS	5
-#define RFC1533_DNS		6
-#define RFC1533_LOGSERVER	7
-#define RFC1533_COOKIESERVER	8
-#define RFC1533_LPRSERVER	9
-#define RFC1533_IMPRESSSERVER	10
-#define RFC1533_RESOURCESERVER	11
-#define RFC1533_HOSTNAME	12
-#define RFC1533_BOOTFILESIZE	13
-#define RFC1533_MERITDUMPFILE	14
-#define RFC1533_DOMAINNAME	15
-#define RFC1533_SWAPSERVER	16
-#define RFC1533_ROOTPATH	17
-#define RFC1533_EXTENSIONPATH	18
-#define RFC1533_IPFORWARDING	19
-#define RFC1533_IPSOURCEROUTING	20
-#define RFC1533_IPPOLICYFILTER	21
-#define RFC1533_IPMAXREASSEMBLY	22
-#define RFC1533_IPTTL		23
-#define RFC1533_IPMTU		24
-#define RFC1533_IPMTUPLATEAU	25
-#define RFC1533_INTMTU		26
-#define RFC1533_INTLOCALSUBNETS	27
-#define RFC1533_INTBROADCAST	28
-#define RFC1533_INTICMPDISCOVER	29
-#define RFC1533_INTICMPRESPOND	30
+#define RFC1533_COOKIE          99, 130, 83, 99
+#define RFC1533_PAD             0
+#define RFC1533_NETMASK         1
+#define RFC1533_TIMEOFFSET      2
+#define RFC1533_GATEWAY         3
+#define RFC1533_TIMESERVER      4
+#define RFC1533_IEN116NS        5
+#define RFC1533_DNS             6
+#define RFC1533_LOGSERVER       7
+#define RFC1533_COOKIESERVER    8
+#define RFC1533_LPRSERVER       9
+#define RFC1533_IMPRESSSERVER   10
+#define RFC1533_RESOURCESERVER  11
+#define RFC1533_HOSTNAME        12
+#define RFC1533_BOOTFILESIZE    13
+#define RFC1533_MERITDUMPFILE   14
+#define RFC1533_DOMAINNAME      15
+#define RFC1533_SWAPSERVER      16
+#define RFC1533_ROOTPATH        17
+#define RFC1533_EXTENSIONPATH   18
+#define RFC1533_IPFORWARDING    19
+#define RFC1533_IPSOURCEROUTING 20
+#define RFC1533_IPPOLICYFILTER  21
+#define RFC1533_IPMAXREASSEMBLY 22
+#define RFC1533_IPTTL           23
+#define RFC1533_IPMTU           24
+#define RFC1533_IPMTUPLATEAU    25
+#define RFC1533_INTMTU          26
+#define RFC1533_INTLOCALSUBNETS 27
+#define RFC1533_INTBROADCAST    28
+#define RFC1533_INTICMPDISCOVER 29
+#define RFC1533_INTICMPRESPOND  30
 #define RFC1533_INTROUTEDISCOVER 31
-#define RFC1533_INTROUTESOLICIT	32
-#define RFC1533_INTSTATICROUTES	33
-#define RFC1533_LLTRAILERENCAP	34
-#define RFC1533_LLARPCACHETMO	35
-#define RFC1533_LLETHERNETENCAP	36
-#define RFC1533_TCPTTL		37
-#define RFC1533_TCPKEEPALIVETMO	38
-#define RFC1533_TCPKEEPALIVEGB	39
-#define RFC1533_NISDOMAIN	40
-#define RFC1533_NISSERVER	41
-#define RFC1533_NTPSERVER	42
-#define RFC1533_VENDOR		43
-#define RFC1533_NBNS		44
-#define RFC1533_NBDD		45
-#define RFC1533_NBNT		46
-#define RFC1533_NBSCOPE		47
-#define RFC1533_XFS		48
-#define RFC1533_XDM		49
+#define RFC1533_INTROUTESOLICIT 32
+#define RFC1533_INTSTATICROUTES 33
+#define RFC1533_LLTRAILERENCAP  34
+#define RFC1533_LLARPCACHETMO   35
+#define RFC1533_LLETHERNETENCAP 36
+#define RFC1533_TCPTTL          37
+#define RFC1533_TCPKEEPALIVETMO 38
+#define RFC1533_TCPKEEPALIVEGB  39
+#define RFC1533_NISDOMAIN       40
+#define RFC1533_NISSERVER       41
+#define RFC1533_NTPSERVER       42
+#define RFC1533_VENDOR          43
+#define RFC1533_NBNS            44
+#define RFC1533_NBDD            45
+#define RFC1533_NBNT            46
+#define RFC1533_NBSCOPE         47
+#define RFC1533_XFS             48
+#define RFC1533_XDM             49
 
-#define RFC2132_REQ_ADDR	50
+#define RFC2132_REQ_ADDR        50
 #define RFC2132_LEASE_TIME      51
-#define RFC2132_MSG_TYPE	53
-#define RFC2132_SRV_ID		54
-#define RFC2132_PARAM_LIST	55
-#define RFC2132_MAX_SIZE	57
+#define RFC2132_MSG_TYPE        53
+#define RFC2132_SRV_ID          54
+#define RFC2132_PARAM_LIST      55
+#define RFC2132_MAX_SIZE        57
 #define RFC2132_RENEWAL_TIME    58
 #define RFC2132_REBIND_TIME     59
 
-#define DHCPDISCOVER		1
-#define DHCPOFFER		2
-#define DHCPREQUEST		3
-#define DHCPACK			5
+#define DHCPDISCOVER            1
+#define DHCPOFFER               2
+#define DHCPREQUEST             3
+#define DHCPACK                 5
 #define DHCPNAK                 6
-#define DHCPRELEASE		7
+#define DHCPRELEASE             7
 
-#define RFC1533_VENDOR_MAJOR	0
-#define RFC1533_VENDOR_MINOR	0
+#define RFC1533_VENDOR_MAJOR    0
+#define RFC1533_VENDOR_MINOR    0
 
-#define RFC1533_VENDOR_MAGIC	128
-#define RFC1533_VENDOR_ADDPARM	129
-#define	RFC1533_VENDOR_ETHDEV	130
+#define RFC1533_VENDOR_MAGIC    128
+#define RFC1533_VENDOR_ADDPARM  129
+#define RFC1533_VENDOR_ETHDEV   130
 #define RFC1533_VENDOR_HOWTO    132
-#define RFC1533_VENDOR_MNUOPTS	160
+#define RFC1533_VENDOR_MNUOPTS  160
 #define RFC1533_VENDOR_SELECTION 176
-#define RFC1533_VENDOR_MOTD	184
+#define RFC1533_VENDOR_MOTD     184
 #define RFC1533_VENDOR_NUMOFMOTD 8
-#define RFC1533_VENDOR_IMG	192
-#define RFC1533_VENDOR_NUMOFIMG	16
+#define RFC1533_VENDOR_IMG      192
+#define RFC1533_VENDOR_NUMOFIMG 16
 
-#define RFC1533_END		255
-#define BOOTP_VENDOR_LEN	64
-#define DHCP_OPT_LEN		312
+#define RFC1533_END             255
+#define BOOTP_VENDOR_LEN        64
+#define DHCP_OPT_LEN            312
 
 struct bootp_t
Index: trunk/src/VBox/Devices/Network/slirp/ctl.h
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/ctl.h	(revision 15092)
+++ trunk/src/VBox/Devices/Network/slirp/ctl.h	(revision 15093)
@@ -1,6 +1,6 @@
-#define CTL_CMD		0
-#define CTL_EXEC	1
-#define CTL_ALIAS	2
-#define CTL_DNS		3
+#define CTL_CMD         0
+#define CTL_EXEC        1
+#define CTL_ALIAS       2
+#define CTL_DNS         3
 #define CTL_BROADCAST   255
 
Index: trunk/src/VBox/Devices/Network/slirp/ip_icmp.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/ip_icmp.c	(revision 15092)
+++ trunk/src/VBox/Devices/Network/slirp/ip_icmp.c	(revision 15093)
@@ -80,5 +80,5 @@
 #else
         pData->icmp_socket.s = IcmpCreateFile();
-    	pData->phEvents[VBOX_ICMP_EVENT_INDEX] = CreateEvent(NULL, FALSE, FALSE, NULL);
+        pData->phEvents[VBOX_ICMP_EVENT_INDEX] = CreateEvent(NULL, FALSE, FALSE, NULL);
 #endif
         insque(pData, &pData->icmp_socket, &udb);
Index: trunk/src/VBox/Devices/Network/slirp/misc.h
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/misc.h	(revision 15092)
+++ trunk/src/VBox/Devices/Network/slirp/misc.h	(revision 15093)
@@ -11,5 +11,5 @@
 struct ex_list
 {
-    int ex_pty;	         /* Do we want a pty? */
+    int ex_pty;          /* Do we want a pty? */
     int ex_addr;         /* The last byte of the address */
     int ex_fport;        /* Port to telnet to */
@@ -32,5 +32,5 @@
 #define EMU_RSH       0x8
 
-#define EMU_NOCONNECT 0x10	/* Don't connect */
+#define EMU_NOCONNECT 0x10      /* Don't connect */
 
 /* UDP emulations */
Index: trunk/src/VBox/Devices/Network/slirp/socket.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/socket.c	(revision 15092)
+++ trunk/src/VBox/Devices/Network/slirp/socket.c	(revision 15093)
@@ -840,8 +840,8 @@
 {
         int len;
-	int i;
+        int i;
         ICMP_ECHO_REPLY *icr;
         u_char code = ~0;
-	len = IcmpParseReplies(pData->pvIcmpBuffer, pData->szIcmpBuffer);
+        len = IcmpParseReplies(pData->pvIcmpBuffer, pData->szIcmpBuffer);
         if (len <= 0) {
               LogRel(("Error (%d) occured on ICMP receiving \n", GetLastError()));  
Index: trunk/src/VBox/Devices/Network/slirp/tcpip.h
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/tcpip.h	(revision 15092)
+++ trunk/src/VBox/Devices/Network/slirp/tcpip.h	(revision 15093)
@@ -1,5 +1,5 @@
 /*
  * Copyright (c) 1982, 1986, 1993
- *	The Regents of the University of California.  All rights reserved.
+ *      The Regents of the University of California.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -13,6 +13,6 @@
  * 3. All advertising materials mentioning features or use of this software
  *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
+ *      This product includes software developed by the University of
+ *      California, Berkeley and its contributors.
  * 4. Neither the name of the University nor the names of its contributors
  *    may be used to endorse or promote products derived from this software
@@ -31,5 +31,5 @@
  * SUCH DAMAGE.
  *
- *	@(#)tcpip.h	8.1 (Berkeley) 6/10/93
+ *      @(#)tcpip.h     8.1 (Berkeley) 6/10/93
  * tcpip.h,v 1.3 1994/08/21 05:27:40 paul Exp
  */
@@ -43,24 +43,24 @@
 struct tcpiphdr
 {
-    struct 	ipovly ti_i;		/* overlaid ip structure */
-    struct	tcphdr ti_t;		/* tcp header */
+    struct      ipovly ti_i;            /* overlaid ip structure */
+    struct      tcphdr ti_t;            /* tcp header */
 };
-#define	ti_next		ti_i.ih_next
-#define	ti_prev		ti_i.ih_prev
-#define	ti_x1		ti_i.ih_x1
-#define	ti_pr		ti_i.ih_pr
-#define	ti_len		ti_i.ih_len
-#define	ti_src		ti_i.ih_src
-#define	ti_dst		ti_i.ih_dst
-#define	ti_sport	ti_t.th_sport
-#define	ti_dport	ti_t.th_dport
-#define	ti_seq		ti_t.th_seq
-#define	ti_ack		ti_t.th_ack
-#define	ti_x2		ti_t.th_x2
-#define	ti_off		ti_t.th_off
-#define	ti_flags	ti_t.th_flags
-#define	ti_win		ti_t.th_win
-#define	ti_sum		ti_t.th_sum
-#define	ti_urp		ti_t.th_urp
+#define ti_next         ti_i.ih_next
+#define ti_prev         ti_i.ih_prev
+#define ti_x1           ti_i.ih_x1
+#define ti_pr           ti_i.ih_pr
+#define ti_len          ti_i.ih_len
+#define ti_src          ti_i.ih_src
+#define ti_dst          ti_i.ih_dst
+#define ti_sport        ti_t.th_sport
+#define ti_dport        ti_t.th_dport
+#define ti_seq          ti_t.th_seq
+#define ti_ack          ti_t.th_ack
+#define ti_x2           ti_t.th_x2
+#define ti_off          ti_t.th_off
+#define ti_flags        ti_t.th_flags
+#define ti_win          ti_t.th_win
+#define ti_sum          ti_t.th_sum
+#define ti_urp          ti_t.th_urp
 
 /*